import { Component, Inject } from '@angular/core';
import { SampleService } from './sample.service';
import React from 'react';
import ReactDOM from 'react-dom';
import DataView from './data-view';

@Component({
  selector: 'samplewithreact',
  templateUrl: './sample-with-react.component.html'
})
export class SampleWithReactComponent {
  constructor(@Inject(SampleService) service ) {
    this.service = service;
    this.subscribers = [];
  }
  
  getData() {
    this.service.get()
      .then(data => this.updateData(data));
  }
  
  updateData(data) { 
    this.data = data;
                                                                  
    this.dataView.updateData(this.data);
  }
  
  addData() {              
    const id = this.data.length + 1;
    const newData = this.data.slice();
    newData.push({ id: id, value: 1 }); 
    this.updateData(newData);
  }
  
  ngOnInit() {
    this.dataView = 
      ReactDOM.render(<DataView parent={this}/>,
        document.getElementById('reacttarget'));
    
    this.updateData([]); 
  }

  ngOnDestory() {                     
    //ReactDOM.unmountComponentAtNode(document.getElementById('reacttarget'));
  }
}
